Dialog resource
{
	Flags _flags = PauseGame | Modal | FirstDraw;
	ElementDescription _rootElement = "main";

	ElementDescription _templates
	[
		"modLine"
	]

	External _references
	[
		"ModDetails.rsc",
	]
}

GroupDescription main
{
	Alignment _alignment = MidCenter;
	ElementDescription _elements
	[
		"SharedElements.rsc:dialogBorder",
		"content"
	]
}

LayoutDescription content
{
	int _leftPad = 8;
	int _rightPad = 8;
	int _topPad = 8;
	int _bottomPad = 8;

	LayoutItem _elements
	[
		{
			String _name = "title";
			ElementDescription _element = "labelTitle";
			LayoutHorizontal _xLayout = LeftToLeft; 
			LayoutVertical _yLayout = TopToTop; int _yOffset = 4;
		}
		{
			String _name = "table";
			ElementDescription _element = "modGroup";
			LayoutHorizontal _xLayout = LeftToLeft; String _xAnchorTo = "title";
			LayoutVertical _yLayout = TopToBottom; String _yAnchorTo = "title";
		}
		{
			String _name = "ok";
			ElementDescription _element = "SharedElements.rsc:buttonOk";
			LayoutHorizontal _xLayout = RightToRight; String _xAnchorTo = "table";
			LayoutVertical _yLayout = TopToBottom; String _yAnchorTo = "table"; int _yOffset = 4;
		}
		{
			String _name = "close";
			ElementDescription _element = "SharedElements.rsc:buttonCancel";
			LayoutHorizontal _xLayout = RightToLeft; String _xAnchorTo = "ok"; int _xOffset = -4;
			LayoutVertical _yLayout = TopToTop; String _yAnchorTo = "ok"; 
		}
	]
}

LabelDescription labelTitle 
{
	Alignment _alignment = MidCenter;

	int _bottomPad = 5;
	int _leftPad = 5;
	int _rightPad = 5;
	int _topPad = 5;

	Font _font = "Font\Font.rsc";
	StringTable _stringTable = "StringTable.rsc:mainMenu";
	SpriteSheet _spriteSheet = "SpriteSheet.rsc";

	int _spacing = 4;
	LabelPosition _labelPosition = TextRight;
	Alignment _textAlignment = MidLeft;

	String _text = "Mod";
	String _spriteName = "Mod";
}

RibbonDescription modGroup
{
	ElementDescription _border = "SharedElements.rsc:sunkenRaisedBorder";

	int _leftPad = 8;
	int _topPad = 8;
	int _rightPad = 8;
	int _bottomPad = 8;

	bool _vertical = true;

	int _cellPad = 4;	

	ElementDescription _elements
	[
		"headerLine"
		"tableList"
	]
}

ContainerDescription tableList
{
	int _width = 596;
	int _height = 350;
	int _scrollSpacing = 4;

	int _leftPad = 0;
	int _topPad = 0;
	int _rightPad = 0;
	int _bottomPad = 0;

	ElementDescription _verticalScroll = "SharedElements.rsc:verticalScrollbar";
	ElementDescription _content = "tableMods";
}

RibbonDescription tableMods
{
	ElementDescription _border = "SharedElements.rsc:sunkenBorder";

	int _leftPad = 4;
	int _rightPad = 4;
	int _bottomPad = 4;
	int _topPad = 4;
	int _cellPad = 4;

	int _minHeight = 350;
	int _minWidth = 580;
	Alignment _alignment = TopLeft;

	bool _vertical = true;
	ElementDescription _elements
	[
	]
}

BorderDescription borderLine : "SharedElements.rsc:flatButtonEnabledBorder"
{
	Color _color = 0x00FFFFFF;
}

LayoutDescription modLine
{
	ElementDescription _border = "borderLine";
	int _leftPad = 1;
	int _topPad = 1;
	int _bottomPad = 1;

	LayoutItem _elements
	[
		{
			String _name = "icon";
			ElementDescription _element = "imageIcon";
			LayoutHorizontal _xLayout = LeftToLeft; 
			LayoutVertical _yLayout = TopToTop; 
		}
		{
			ElementDescription _element = "imageConflict";
			LayoutHorizontal _xLayout = RightToRight;  String _xAnchorTo = "icon";
			LayoutVertical _yLayout = BottomToBottom; String _yAnchorTo = "icon";
		}
		{
			String _name = "title";
			ElementDescription _element = "textModName";
			LayoutHorizontal _xLayout = LeftToRight; String _xAnchorTo = "icon"; int _xOffset = 4;
			LayoutVertical _yLayout = TopToTop; String _yAnchorTo = "icon"; 
		}
		{
			String _name = "author";
			ElementDescription _element = "textModAuthor";
			LayoutHorizontal _xLayout = LeftToLeft; String _xAnchorTo = "version";
			LayoutVertical _yLayout = TopToBottom; String _yAnchorTo = "version";
		}
		{
			String _name = "version";
			ElementDescription _element = "textModVersion";
			LayoutHorizontal _xLayout = LeftToLeft; String _xAnchorTo = "title"; 
			LayoutVertical _yLayout = TopToBottom; String _yAnchorTo = "title"; 
		}
		{
			String _name = "desc";
			ElementDescription _element = "textModDescription";
			LayoutHorizontal _xLayout = LeftToLeft; String _xAnchorTo = "title"; int _xOffset = 200;
			LayoutVertical _yLayout = TopToTop; String _yAnchorTo = "title"; 
		}
		{
			String _name = "loaded";
			ElementDescription _element = "textLoaded";
			LayoutHorizontal _xLayout = LeftToRight; String _xAnchorTo = "buttonLoaded"; int _xOffset = 4;
			LayoutVertical _yLayout = TopToTop; String _yAnchorTo = "buttonLoaded"; 
		}
		{
			String _name = "buttonLoaded";
			ElementDescription _element = "checkLoaded";
			LayoutHorizontal _xLayout = LeftToLeft; String _xAnchorTo = "desc"; int _xOffset = 230;
			LayoutVertical _yLayout = TopToTop; String _yAnchorTo = "desc"; 
		}
		{
			String _name = "details";
			ElementDescription _element = "buttonDetails";
			LayoutHorizontal _xLayout = LeftToLeft; String _xAnchorTo = "buttonLoaded"; 
			LayoutVertical _yLayout = TopToBottom; String _yAnchorTo = "buttonLoaded"; int _yOffset = 4;
		}
		{
			String _name = "top";
			ElementDescription _element = "buttonTop";
			LayoutHorizontal _xLayout = LeftToRight; String _xAnchorTo = "details"; int _xOffset = 2;
			LayoutVertical _yLayout = TopToTop; String _yAnchorTo = "details"; 
		}
		{
			String _name = "up";
			ElementDescription _element = "buttonUp";
			LayoutHorizontal _xLayout = LeftToRight; String _xAnchorTo = "top"; 
			LayoutVertical _yLayout = TopToTop; String _yAnchorTo = "top"; 
		}
		{
			String _name = "down";
			ElementDescription _element = "buttonDown";
			LayoutHorizontal _xLayout = LeftToRight; String _xAnchorTo = "up"; 
			LayoutVertical _yLayout = TopToTop; String _yAnchorTo = "up"; 
		}
	]
}

ImageDescription imageIcon
{
	ElementDescription _border = "SharedElements.rsc:raisedBorder";

	SpriteSheet _spriteSheet = "SpriteSheet.rsc";
	String _spriteName = "White";
	Color _color = 0xFFFFFFFF;	
	int _width = 48;
	int _height = 48;
}

ImageDescription imageConflict
{
	SpriteSheet _spriteSheet = "SpriteSheet.rsc";
	String _spriteName = "EventIcon13";
	int _width = 24;
	int _height = 24;

	Dialog _toolTipDialog = "ToolTip.rsc";
	StringTable _toolTipStringTable = "StringTable.rsc:mainMenu";
	String _toolTipText = "ModConflict";

}

/*
RibbonDescription modLine
{
	bool _vertical = false;
	ElementDescription _border = "borderLine";

	ElementDescription _elements
	[
		"textModName"
		"textModAuthor"
		"textModVersion",
		"groupLoaded",
		"buttonTop",
		"buttonUp",
		"buttonDown",
	]
}
*/
RibbonDescription headerLine
{
	bool _vertical = false;
	ElementDescription _border = "SharedElements.rsc:sunkenBorder";

	int _leftPad = 4;
	int _topPad = 4;
	int _rightPad = 4;
	int _bottomPad = 4;

	ElementDescription _elements
	[
		"textName",
		"textDesc",
		"textOrder",
	]
}

TextDescription textHeader
{
	StringTable _stringTable = "StringTable.rsc:mainMenu";
	Font _font = "Font\FontMedium.rsc";
	Alignment _alignment = MidCenter;
}

TextDescription textName : "textHeader" { String _text = "ModName"; int _minWidth = 200; int _leftPad = 52; }
TextDescription textDesc : "textHeader" { String _text = "ModDescription"; int _minWidth = 250;}
TextDescription textVersion : "textHeader" { String _text = "ModVersion"; int _minWidth = 74; }
TextDescription textLoaded : "textHeader" { String _text = "ModLoaded"; int _minWidth = 48; }
TextDescription textOrder : "textHeader" { String _text = "ModOrder"; int _minWidth = 64; }

RibbonDescription groupNameAuthor
{
	bool _vertical = true;
	ElementDescription _elements
	[
		"textModName"
		"textModAuthor"
	]
}

TextDescription textModName 
{ 
	StringTable _stringTable = "StringTable.rsc:general";
	String _text = "Parameter";
	Font _font = "Font\FontMedium.rsc";
}

TextDescription textModAuthor
{
	StringTable _stringTable = "StringTable.rsc:general";
	String _text = "Parameter";
	Font _font = "Font\FontSmall.rsc";
}

TextDescription textModVersion
{
	StringTable _stringTable = "StringTable.rsc:mainMenu";
	String _text = "ModVersion";
	Font _font = "Font\FontSmall.rsc";
	Alignment _alignment = MidCenter;
}

TextDescription textModDescription
{
	StringTable _stringTable = "StringTable.rsc:general";
	String _text = "Parameter";
	Font _font = "Font\FontSmall.rsc";
	Alignment _alignment = MidCenter;
	bool _wordWrap = true;
	int _wordWrapSize = 192;
}

GroupDescription groupLoaded 
{
	int _minWidth = 48;
	ElementDescription _elements
	[
		"checkLoaded"
	]
}

CheckDescription checkLoaded : "SharedElements.rsc:raisedButton"
{
	ElementDescription _check = "checkLoadedChecked";
	ElementDescription _content = "checkLoadedUnchecked";

	Alignment _alignment = MidCenter;

	Color _enabledColor = 0xFF2E2B28;
	Color _disabledColor = 0xFF2E2B28;
	Color _highlightedColor = 0xFF2E2B28;
	Color _pressedColor = 0xFF2E2B28;

	Dialog _toolTipDialog = "ToolTip.rsc";
	StringTable _toolTipStringTable = "StringTable.rsc:mainMenu";
	String _toolTipText = "ModLoadedTip";
}

ImageDescription checkLoadedChecked
{
	int _topPad = 1;
	int _leftPad = 1;
	int _rightPad = 1;
	int _bottomPad = 1;
	SpriteSheet _spriteSheet = "SpriteSheet.rsc";
	String _spriteName = "SimpleCheck";	
}

ImageDescription checkLoadedUnchecked : "checkLoadedChecked"
{
	Color _color = 0xFF2E2B28;
}

ImageDescription imageLocked
{
	int _minWidth = 64;	
	Alignment _alignment = MidCenter;
	SpriteSheet _spriteSheet = "SpriteSheet.rsc";
	String _spriteName = "Lock";
}

ButtonDescription buttonTop : "SharedElements.rsc:raisedButton"
{
	ElementDescription _content = "textTop";

	Dialog _toolTipDialog = "ToolTip.rsc";
	StringTable _toolTipStringTable = "StringTable.rsc:mainMenu";
	String _toolTipText = "ModTopTip";
}

ButtonDescription buttonUp : "SharedElements.rsc:raisedButton"
{
	ElementDescription _content = "imageUp";
	int _leftPad = 2;

	Dialog _toolTipDialog = "ToolTip.rsc";
	StringTable _toolTipStringTable = "StringTable.rsc:mainMenu";
	String _toolTipText = "ModUpTip";
}

ButtonDescription buttonDown : "SharedElements.rsc:raisedButton"
{
	ElementDescription _content = "imageDown";
	int _leftPad = 2;

	Dialog _toolTipDialog = "ToolTip.rsc";
	StringTable _toolTipStringTable = "StringTable.rsc:mainMenu";
	String _toolTipText = "ModDownTip";
}

ButtonDescription buttonDetails : "SharedElements.rsc:raisedButton"
{
	ElementDescription _content = "textDetails";

	Dialog _toolTipDialog = "ToolTip.rsc";
	StringTable _toolTipStringTable = "StringTable.rsc:mainMenu";
	String _toolTipText = "ModDetailsTip";

}

TextDescription textTop
{ 
	StringTable _stringTable = "StringTable.rsc:mainMenu";
	String _text = "ModTop";
	Font _font = "Font\FontSmall.rsc";

	int _leftPad = 8;
	int _rightPad = 8;
	int _topPad = 1;
	int _bottomPad = 2;
}

TextDescription textDetails
{ 
	StringTable _stringTable = "StringTable.rsc:mainMenu";
	String _text = "ModDetails";
	Font _font = "Font\FontSmall.rsc";

	int _leftPad = 4;
	int _rightPad = 4;
	int _topPad = 1;
	int _bottomPad = 2;
}


ImageDescription imageUp
{
	SpriteSheet _spriteSheet = "SpriteSheet.rsc";
	String _spriteName = "ArrowUp";
	int _bottomPad = 1;
}

ImageDescription imageDown
{
	SpriteSheet _spriteSheet = "SpriteSheet.rsc";
	String _spriteName = "ArrowDown";
	int _bottomPad = 1;
}
