Material resource
{
	MaterialType _type = Opaque;
	VideoProgram _passes
	[ 
		"normal"
		"depth"
	]
}

VideoProgram normal
{
	VertexLayout _vertexLayout = "MeshLayout\ModelSkinLayout.rsc";
	VertexProgram _vertexProgram = "vs";
	PixelProgram _pixelProgram = "Material\Opaque\OpaqueMaterial.rsc:ps";
	RenderState _renderState = "Material\Opaque\OpaqueMaterial.rsc:rs";
}

VideoProgram depth
{
	VertexLayout _vertexLayout = "MeshLayout\ModelSkinDepthLayout.rsc";
	VertexProgram _vertexProgram = "Material\OpaqueSkin\OpaqueSkinMaterial.rsc:vsDepth";
	PixelProgram _pixelProgram = "Material\Opaque\OpaqueMaterial.rsc:psDepth";
	RenderState _renderState = "Material\Opaque\OpaqueMaterial.rsc:rsDepth";
}


VertexProgram vs : "Material\OpaqueSkin\OpaqueSkinMaterial.rsc:vs"
{
	String _functions
	[
		"
		void Common(float4x4 localToWorld, float4 position, float4 texcoord, float3 normal, float4 index, float4 weight, out float3 worldPosition, out float4 outputPosition,
			out float4 outputTexcoord, out float3 lightFog)
		{
			position.xyz = SkinPosition(position.xyz / 512.0f, index, weight);
			position.xyz *= localToWorld[3].xyz;

			normal = SkinNormal(normal * 2.0 - 1.0, index, weight);
	
			worldPosition = mul((float3x4)localToWorld, float4(position.xyz, 1.0));
			outputPosition = mul(gc_worldToProjection, float4(worldPosition, 1.0));
	
			normal = mul((float3x3)localToWorld, normal).xyz;
	
			lightFog = GetLightingFog(normal, outputPosition.w);
	
			outputTexcoord = texcoord / float4(512.0, 512.0, 8192.0, 8192.0);
			outputTexcoord.x = (outputTexcoord.x + localToWorld[3][3]) / 8.0;
		}
		"
	]
}
