Material resource
{
	MaterialType _type = Blended;
	VideoProgram _passes
	[ 
		"normal"
	]
}

VideoProgram normal
{
	VertexLayout _vertexLayout = "MeshLayout\ParticleLayout.rsc";
	VertexProgram _vertexProgram = "vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "rs";
}

RenderState rs
{
	AlphaBlend _alphaBlend
	{
		bool _enable = true;
		Blend _source = SourceAlpha;
		Blend _dest = InverseSourceAlpha;
		BlendOp _op = Add;
		ColorWrite _writeMask = Red | Green | Blue | Alpha;
	}
	Depth _depth
	{
		bool _enable = true;
		bool _write = false;
		Compare _compare = Less;
		float _bias = 0.000000;
		float _slopeBias = 0.000000;
	}
	Stencil _stencil
	{
		bool _enable = false;
		bool _twosided = false;
		Compare _compare = Greater;
		uchar _ref = 0;
		StencilOp _fail = Keep;
		StencilOp _zFail = Keep;
		StencilOp _pass = Keep;
		StencilOp _tsFail = Keep;
		StencilOp _tsZFail = Keep;
		StencilOp _tsPass = Keep;
	}
	CullMode _cullMode = None;
	CullMode _fillMode = Solid;
}


VertexProgram vs
{
	bool _instanced = true;
	VertexLayout _input = "MeshLayout/ParticleLayout.rsc";
	String _includes
	[
		"Material/Instancing.hlsl"
	]

	Output _outputs 
	[
		{ String _type = "float4"; String _name = "position";		Usage _usage = Position;			int _index = 0; }
		{ String _type = "float3"; String _name = "texcoordFog";	Usage _usage = TextureCoordinate;	int _index = 0; }
		{ String _type = "float3"; String _name = "lightDir";		Usage _usage = TextureCoordinate;	int _index = 1; }
		{ String _type = "float4"; String _name = "color";			Usage _usage = TextureCoordinate;	int _index = 2; }
	]

	Variant _variants
	[
		{
			String _text = "
				float s, c;
				sincos(input.roll, s, c);
				float2x2 rollMatrix = float2x2(float2(c, -s), float2(s, c));
				input.uvOffset.zw = mul(rollMatrix, input.uvOffset.zw);

				float3 right = gc_worldToCamera[0].xyz * input.uvOffset.z;
				float3 up = gc_worldToCamera[2].xyz * input.uvOffset.w;

				float4x4 localToWorld = GetLocalToWorld(input.position.w);

				float3 worldPosition = mul((float3x4)localToWorld, float4(input.position.xyz, 1.0));

				worldPosition.xyz = worldPosition + right + up;

				output.position = mul(gc_worldToProjection, float4(worldPosition, 1.0));

				float3x3 tangentBasis = float3x3(
					float3(c, -s, 0.0),
					float3(s, c, 0.0),
					float3(0, 0, 1.0));

				output.lightDir = mul(tangentBasis, normalize(float3(0.707, 0.707, 0.5)));
	
				output.texcoordFog.xy = input.uvOffset.xy;
				output.texcoordFog.z = (gc_fog.x + output.position.z) * gc_fog.y;
				input.color.w *= localToWorld[3][3];
				output.color = input.color;
			";
		}
	]
}

PixelProgram ps
{
	VertexProgram _input = "vs";

	String _includes
	[
		"Material/Texture.hlsl"
	]

	Texture _textureList
	[
		{ bool _2d = true;	String _name = "diffuse";	int _bindIndex = 0;	bool _exposed = true; }
		{ bool _2d = true;	String _name = "normal";	int _bindIndex = 1;	bool _exposed = true; }
	]

	Variant _variants
	[
		{
			String _text = "
				float3 norm;
				norm.xy = Sample2D(normal, normalsampler, input.texcoordFog.xy).wy * 2 - 1;
				norm.z = 1.0 - sqrt(dot(norm.xy, norm.xy));
				float d = dot(norm, input.lightDir) * 2; d = d * d;
				float3 lighting = saturate(d * pc_lightColor.xyz) + saturate((d + 1.0) / 2.0) * pc_ambientColor.xyz;

				output.color = Sample2D(diffuse, diffusesampler, input.texcoordFog.xy) * input.color;
				output.color.xyz *= lighting;
				output.color.xyz = lerp(output.color.xyz, pc_fogColor.xyz, saturate(min(input.texcoordFog.z, pc_fogColor.w)));
			";
		}
	]
}