Material resource
{
	MaterialType _type = Blended;
	VideoProgram _passes
	[ 
		"normal"
	]
}

VideoProgram normal
{
	VertexLayout _vertexLayout = "MeshLayout\SelectionEdgeSkinLayout.rsc";
	VertexProgram _vertexProgram = "vs";
	PixelProgram _pixelProgram = "Material\SelectionEdge\SelectionEdgeMaterial.rsc:ps";
	RenderState _renderState = "Material\SelectionEdge\SelectionEdgeMaterial.rsc:rs";
}


VertexProgram vs
{
	VertexLayout _input = "MeshLayout/SelectionEdgeSkinLayout.rsc";
	String _includes
	[
		"Material/Instancing.hlsl"
		"Material/Skinning.hlsl"
	]

	Output _outputs 
	[
		{ String _type = "float4"; String _name = "position";		Usage _usage = Position;			int _index = 0; }
	]

	Variant _variants
	[
		{
			String _text = "
				float4x4 localToWorld = GetLocalToWorld(input.positionB.w);

				float3 positionA = input.positionA * 1.0 / 512.0;
				float3 positionB = input.positionB * 1.0f / 512.0;

				positionA.xyz = SkinPosition(positionA.xyz, input.indexA, input.weightA);
				positionB.xyz = SkinPosition(positionB.xyz, input.indexB, input.weightB);

				float3 worldPositionA = mul((float3x4)localToWorld, float4(positionA.xyz * localToWorld[3].xyz, 1.0));
				float3 worldPositionB = mul((float3x4)localToWorld, float4(positionB.xyz * localToWorld[3].xyz, 1.0));

				float3 cameraRight = gc_worldToCamera[0].xyz;
				float3 cameraForward = gc_worldToCamera[1].xyz;

				float3 lineDirection = normalize(worldPositionB - worldPositionA);
				float3 widthDirection = normalize(cross(lineDirection, cameraForward));

				float4 r0 = mul(gc_worldToProjection, float4(worldPositionA, 1.0));
				float4 r1 = mul(gc_worldToProjection, float4(worldPositionA + cameraRight, 1.0));
				r0.xyz /= r0.w;
				r1.xyz /= r1.w;
				float edgeSize = 4;
				float size = edgeSize * (1.0 / (r1.x - r0.x)) * ic_inverseScale.w;

				worldPositionA = worldPositionA - (lineDirection * size) + (widthDirection * input.positionA.w / 512.0 * size);
				output.position = mul(gc_worldToProjection, float4(worldPositionA, 1.0));
			";
		}
	]
}