Material resource
{
	MaterialType _type = Opaque;
	VideoProgram _passes
	[ 
		"normal"
		"depth"
		"reflect"
	]
}

VideoProgram normal
{
	VertexLayout _vertexLayout = "MeshLayout\ModelDepthLayout.rsc";
	VertexProgram _vertexProgram = "vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "rs";
}

VideoProgram depth
{
	// no depth - just empty...
}

VideoProgram reflect
{
	VertexLayout _vertexLayout = "MeshLayout\ModelDepthLayout.rsc";
	VertexProgram _vertexProgram = "vs";
	PixelProgram _pixelProgram = "ps";
	RenderState _renderState = "rsRef";
}

RenderState rsRef : "rs"
{
	CullMode _cullMode = FrontFaces;
}

RenderState rs
{
	AlphaBlend _alphaBlend
	{
		bool _enable = false;
		Blend _source = One;
		Blend _dest = Zero;
		BlendOp _op = Add;
		ColorWrite _writeMask = Red | Green | Blue | Alpha;
	}
	Depth _depth
	{
		bool _enable = false;
		bool _write = false;
		Compare _compare = LessEqual;
		float _bias = 0.000000;
		float _slopeBias = 0.000000;
	}
	Stencil _stencil
	{
		bool _enable = false;
		bool _twosided = false;
		Compare _compare = Greater;
		uchar _ref = 0;
		StencilOp _fail = Keep;
		StencilOp _zFail = Keep;
		StencilOp _pass = Keep;
		StencilOp _tsFail = Keep;
		StencilOp _tsZFail = Keep;
		StencilOp _tsPass = Keep;
	}
	CullMode _cullMode = BackFaces;
	CullMode _fillMode = Solid;
}

VertexProgram vs
{
	bool _instanced = false;
	VertexLayout _input = "MeshLayout/ModelDepthLayout.rsc";
	String _includes
	[
		"Material/Instancing.hlsl"
	]

	Output _outputs 
	[
		{ String _type = "float4"; String _name = "position";		Usage _usage = Position;			int _index = 0; }
		{ String _type = "float3"; String _name = "texcoord";		Usage _usage = TextureCoordinate;	int _index = 0; }
	]

	Variant _variants
	[
		{
			String _text = "
				float3 position = input.position / 512.0;
				output.texcoord = position;

				position *= 512.0;

				float4x4 localToWorld = GetLocalToWorld(input.position.w);
				float3 worldPosition = mul((float3x4)localToWorld, float4(position.xyz, 1.0));
				output.position = mul(gc_worldToProjection, float4(worldPosition, 1.0));
				
			";
		}
	]
}

PixelProgram ps
{
	VertexProgram _input = "vs";

	String _includes
	[
		"Material/Texture.hlsl"
	]

	Texture _textureList
	[
		{ bool _2d = false;	String _name = "clear";		int _bindIndex = 0;	bool _exposed = true; }
	]

	Variant _variants
	[
		{
			String _text = "
				float4 clearSky = SampleCUBE(clear, clearsampler, input.texcoord);
				float4 cloudySky = SampleCUBE(clear, clearsampler, float3(input.texcoord.x, input.texcoord.y, -input.texcoord.z));

				/* winter will use half cloudy, fully cloudy when weather is occuring */
				float t = lerp(pc_userPosition.x * 0.75, 1.0, pc_userPosition.w);

				output.color = lerp(clearSky, cloudySky, t);
			";
		}
	]
}