#ifndef _Texture_HLSL_
#define _Texture_HLSL_

#ifdef _WinDX9
	#define Sample2D(tex_, sampler_, coord_) tex2D(tex_, coord_.xy)
	#define Sample2DProj(tex_, sampler_, coord_) tex2Dproj(tex_, coord_)
	#define SampleShadow(tex_, sampler_, coord_) tex2Dproj(tex_, coord_)
	#define SampleCUBE(tex_, sampler_, coord_) texCUBE(tex_, (coord_).xyz)
#else
	#define Sample2D(tex_, sampler_, coord_) tex_.Sample(sampler_, (coord_).xy)
	#define Sample2DProj(tex_, sampler_, coord_) tex_.Sample(sampler_, coord_.xy / (coord_).w)
	#define SampleShadow(tex_, sampler_, coord_) tex_.SampleCmpLevelZero(sampler_, (coord_).xy, (coord_).z)
	#define SampleCUBE(tex_, sampler_, coord_) tex_.Sample(sampler_, (coord_).xyz)
#endif

#endif
